!(function(global) {

	/*
	获取上月天数
	*/
	function getPreMonthDays(year, month){
		return new Date(year, month, 0).getDate();
	}

	var nowDate = new Date();
	var year = nowDate.getFullYear();
	var month = nowDate.getMonth() + 1;
	var day = nowDate.getDate();
	var years = [year];
	var months = [month];
	//day = 4;
	var maxDays = 7; // 仅允许近8天范围，当天+过去7天
	var daysList = [];
	var dstart = day - maxDays;
	if(dstart <= 0){
		var lastMonth = month - 1;
		months.unshift(lastMonth);
		var maxOfMonth = getPreMonthDays(year, lastMonth);
		var days = [];
		for(var i = 0; i <= Math.abs(dstart); i++){
			var dday = maxOfMonth - i;
			days.unshift(dday);
		}
		daysList.push(days);
		dstart = 1;
	}

	var days = [];
	for(var i = dstart; i <= day; i++){
		days.push(i);
	}
	daysList.push(days);
	var curDays = daysList[daysList.length - 1];
	var lastMonthSelect = months.length - 1;
	var lastDateSelect = curDays.length - 1;

	$('sl-date').innerHTML = year + '-' + (month < 10 ? '0' + month : month) + '-' + (day < 10 ? '0' + day : day);

	function $showDatePicker(selectedColumn, selectedIndex){
		curDays = daysList[daysList.length - 1];
		lastMonthSelect = months.length - 1;
		lastDateSelect = curDays.length - 1;
		if(selectedColumn && selectedColumn >= 0){
			curDays = daysList[selectedIndex];
			lastMonthSelect = selectedIndex;
			lastDateSelect = curDays.length - 1;
		}
		var _data = [years, months, curDays];
		var _title = '选择日期';
		var _value = [0, lastMonthSelect, lastDateSelect]; // 初始选中项索引
		mipm.getSyncDate({
			data: _data,
			title: _title,
			value: _value 
		}, function(ret){
			//console.log(JSON.stringify(ret));
			if(ret.type == 'selected'){
				if(1 == ret.column){
					$showDatePicker(ret.column, ret.value);
				}
				return;
			}
			if(ret.type == 'confirm'){
				var values = ret.value;
				var y = years[values[0]];
				var m = months[values[1]];
				var d = curDays[values[2]];
				//lastDateSelect = values[2];
				var str = y + '-' + (m < 10 ? '0' + m : m) + '-' + (d < 10 ? '0' + d : d);
				$('sl-date').innerText = str;
			}
		});
	}

	const stimes = [
		'00:00', '01:00', '02:00', '03:00',
		'04:00', '05:00', '06:00', '07:00',
		'08:00', '09:00', '10:00', '11:00',
		'12:00', '13:00', '14:00', '15:00',
		'16:00', '17:00', '18:00', '19:00',
		'20:00', '21:00', '22:00', '23:00'
	];
	var lastStimeSelect = 0;
	var lastFtimeSelect = stimes.length - 1;

	function $showTimePicker(start){
		var _data = stimes;
		var _title = '选择开始时间';
		var _value = lastStimeSelect; // 初始选中项索引
		if(!start){
			_data = _data.slice(1);
			_data.push('24:00');
			_title = '选择结束时间';
			_value = lastFtimeSelect; // last
		}
		mipm.getSyncTime({
			data: _data,
			title: _title,
			start: start,
			value: _value
		}, function(ret){
			//console.log(JSON.stringify(ret));
			if(ret.type == 'confirm'){
				var values = ret.value;
				if(start){
					$('sl-time-s').innerText = _data[values[0]];
					lastStimeSelect = values[0];
				}else{
					$('sl-time-f').innerText = _data[values[0]];
					lastFtimeSelect = values[0];
				}
			}
		});
	}

	function $pickerTimeValidate(){
		return lastFtimeSelect >= lastStimeSelect;
	}

	global.showDatePicker = $showDatePicker;
	global.showTimePicker = $showTimePicker;
	global.pickerTimeValidate = $pickerTimeValidate;
})(window);